########################################
###### least squares function ##########
########################################

least_square <- function(ref, crypt) {
  
  #### 1. create df containing shifts ####
    
  # add buffers to crypt and ref frames
  ref.vec<-c(rep(0,10),ref,rep(0,10))
  crypt.vec<-c(rep(0,10),crypt,rep(0,10))
  
  #new df containing ref distribution shifted by different amounts
  new.df<-data.frame(1:length(ref.vec))
  
  #iterate through each possible shift
  #create column containing shifted reference and add to new.df
  for(shift in seq(5,-5,by = -1)) {
    
    new.vector<-c(rep(0,length(ref.vec)))
    a<-1
    
    while (a <= length(ref.vec)) {
      
      b<-a+shift
      
      if (b > length(ref.vec)) {
        
        b<-length(ref.vec)
        
      }
      
      new.vector[b]<-ref.vec[a]
      
      a<-a+1
      
    }
    
    vector.df<-as.data.frame(new.vector)
    colnames(vector.df)<-paste("shift",shift,sep="_")
    new.df<-cbind(new.df,vector.df)
    
  }
  
  shift.df<-new.df[,-1]
  
  ##### 2. create least squares values for sample #####
  b<-1
  
  ls.df<-as.data.frame(0:100)
  
  while (b <= ncol(shift.df)) {
    
    shift.temp<-shift.df[,b]
    sum.vector<-c()
    name.vector<-c()
    
    for (phi in seq(0,1, by = 0.01)) {
      
      name<-paste("phi",phi,sep="_")
      name.vector<-c(name.vector,name)
      mix.temp<-(shift.df[,"shift_0"]*(1-phi))+(shift.temp*phi)
      sum.temp<-sum((crypt.vec-mix.temp)^2)
      sum.vector<-c(sum.vector,sum.temp)
      
    }
    
    sum.df<-as.data.frame(sum.vector)
    rownames(sum.df)<-name.vector
    colnames(sum.df)<-colnames(shift.df)[b]
    ls.df<-cbind(ls.df,sum.df)
    
    b<-b+1
  }
  
  ls.df<-ls.df[,-1]
  
  return(ls.df)
  
}